<template>
  <div class="lg:col-span-1 rounded-2xl lg:w-full lg:h-full lg:bg-gradient-to-r lg:from-gray-50 lg:via-transparent lg:to-transparent dark:from-neutral-800">
    <div class="sticky top-12 start-0 py-8 lg:ps-8 overflow-y-scroll h-screen no-scrollbar pb-10">
        <div class="flex justify-between items-center mb-4">
          <div>
            <a :href="props.news.sourceURL" target="_blank" type="button" class="py-2.5 px-5 me-2 mb-2 text-sm font-medium text-gray-900 focus:outline-none bg-white rounded-lg border border-gray-200 hover:bg-gray-100 hover:text-blue-700 focus:z-10 focus:ring-4 focus:ring-gray-100">
              <UIcon name="i-heroicons-arrow-top-right-on-square-16-solid" />
              View article
            </a>
            <button @click="copyUrlToClipboard" type="button" class="py-2.5 px-5 me-2 mb-2 text-sm font-medium text-gray-900 focus:outline-none bg-white rounded-lg border border-gray-200 hover:bg-gray-100 hover:text-blue-700 focus:z-10 focus:ring-4 focus:ring-gray-100">
              <UIcon name="i-heroicons-share" size="xl" />
              Share
            </button>
          </div>
          <button
              type="button"
              class="py-2.5 px-5 me-2 mb-2 text-sm font-medium text-gray-900 focus:outline-none bg-white rounded-lg border border-gray-200 hover:bg-gray-100 hover:text-blue-700 focus:z-10 focus:ring-4 focus:ring-gray-100"
              @click="submitLike"
          >
            <UIcon v-if="!props.isLike" name="i-heroicons-heart" size="2xl" class="text-xl" />
            <UIcon v-else name="i-heroicons-heart-solid" size="2xl" class="text-xl text-red-600" />
          </button>
        </div>

      <div v-if="props.comments" class="max-w-2xl mx-auto px-4">
        <div class="flex justify-between items-center mb-6">
          <h2 class="text-lg lg:text-2xl font-bold text-gray-900 dark:text-white">Commentaires ({{ props.comments.length }})</h2>
        </div>
        <UForm :schema="schema" :state="state" @submit="onSubmit" class="mb-6">
          <div class="py-2 px-4 mb-4 bg-white rounded-lg rounded-t-lg border border-gray-200 dark:bg-gray-800 dark:border-gray-700">
            <UFormGroup label="Ton commentaire" name="flux-name">
              <UTextarea v-model="state.text" color="primary" variant="outline" placeholder="Search..." />
            </UFormGroup>
          </div>
          <UButton type="submit" :loading="loading"
                  class="inline-flex items-center py-2.5 px-4 text-xs font-medium text-center text-white bg-primary-700 rounded-lg focus:ring-4 focus:ring-primary-200 dark:focus:ring-primary-900 hover:bg-primary-800">
            Post comment
          </UButton>
        </UForm>
        <card-comment v-if="props.comments" v-for="(comment, index) in props.comments" :key="index" :comment="comment" />
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">

import {type InferType, object, string} from "yup";
import type {FormSubmitEvent} from "#ui/types";
import {useNuxtApp} from "#app";
import type {Api} from "~/types/api";
import {useAuthStore} from "~/store/auth";

const error = ref('')
const loading = ref(false)

const schema = object({
  text: string().required()
})

type Schema = InferType<typeof schema>

const state = reactive({
  text: ''
})

const props = defineProps({
  news: {
    type: Object,
    required: true
  },
  comments: {
    type: Object,
    required: true
  },
  isLike: {
    type: Boolean,
    required: true
  }
})
const nuxtApp = useNuxtApp()
const $api = nuxtApp.$api as Api
const toast = useToast()
const emit = defineEmits([ 'load-data' ])
const router = useRouter()

async function onSubmit (event: FormSubmitEvent<Schema>) {

  if (!authenticated.value) {
    toast.add({
      title: `Vous devez être connecté`,
      description: 'Connectez-vous ou inscrivez-vous',
      actions: [{
        label: 'Me connecter',
        variant: 'link',
        color: 'green',
        click: async () => {
          await router.push('/login')
        }
      },{
        label: `M'inscrire`,
        variant: 'link',
        color: 'green',
        click: async () => {
          await router.push('/register')
        }
      }]
    })
    state.text = ''
    return
  }
  loading.value = true
  const data = ref({
    text: event.data.text,
  })

  const response = await $api.createComments(props.news.News_id, data.value)
  if (response) {
    toast.add({ title: 'Commentaire ajouté' })
    emit('load-data')
    state.text = ''
  } else {
    error.value = 'Un problème est survenu'
    toast.add({ title: 'Un problème est survenu' })
  }
  loading.value = false
}

const copyUrlToClipboard = () => {
  const fullPath = window.location.href;
  navigator.clipboard.writeText(fullPath)
      .then(() => {
        toast.add({ title: 'Url copié dans le presse papier' })
      })
      .catch((err) => {
        console.error('Failed to copy URL:', err);
        toast.add({ title: 'Un problème est survenu' })
      });
};
const { authenticated } = storeToRefs(useAuthStore());

async function submitLike() {
  if (!authenticated.value) {
    toast.add({
      title: `Vous devez être connecté`,
      description: 'Connectez-vous ou inscrivez-vous',
      actions: [{
        label: 'Me connecter',
        variant: 'link',
        color: 'green',
        click: async () => {
          await router.push('/login')
        }
      },{
        label: `M'inscrire`,
        variant: 'link',
        color: 'green',
        click: async () => {
          await router.push('/register')
        }
      }]
    })
    return
  }
  const response = await $api.postLike(props.news.News_id)
  if (response) {
    emit('load-data')
  } else {
    error.value = 'Un problème est survenu'
    toast.add({ title: 'Un problème est survenu' })
  }
}

</script>

<style>
.no-scrollbar::-webkit-scrollbar {
  display: none;
}
/* Hide scrollbar for IE, Edge and Firefox */
.no-scrollbar {
  -ms-overflow-style: none;  /* IE and Edge */
  scrollbar-width: none;  /* Firefox */
}
</style>